/*
 * animacja powstaa w 2004 roku jako wygaszacz ekranu 
 * dla mojej sodkiej drugiej poowy :) potem przerodzia 
 * si w gr komputerow.
 *
 * opis poszczeglnych obiektw znajduje si w pliku 
 * objects.c.
 */

#include <assert.h>
#include <malloc.h>
#include <conio.h>
#include <stdio.h>
#include <dos.h>
#include <i86.h>
#include <mem.h>

#define	TICK_FREQ 36

#pragma aux setvmode = "int 0x10", parm [ax]
#define sync_bufs() memcpy ((char far *) 0xA0000000L, vbuf, 64000)

enum {
	ST_FADEIN = 0,
	ST_SUSTAIN,
	ST_FADEOUT,
	ST_DONE
};

void setvmode (unsigned short int);
char far *mbuf, *vbuf;
char *pal, *keytab;
signed short int *sincos;
volatile char pstate = ST_FADEIN;
volatile char mstate = ST_FADEIN;
volatile char in_irq1 = 0;
volatile int mphase = 0;

void (__interrupt __far *old0) (void);
void (__interrupt __far *old1) (void);

void init_objects (void);
void deinit_objects (void);
void move_objects (void);
void draw_objects (void);

void do_pal (void)
{
	static char mypal[768];
	static char ftime = 1;
	static char div = 0;
	int i;
	char done = 1;

	if (in_irq1)
		return;

	if (div++ < 1)
		return;

	div = 0;

	if (pstate == ST_SUSTAIN || pstate == ST_DONE)
		return;

	if (ftime) {
		ftime = 0;

		if (pstate == ST_FADEIN)
			bzero (mypal, sizeof(mypal));
		else
			memcpy (mypal, pal, sizeof(mypal));
	}

	if (pstate == ST_FADEIN) {
		for (i = 0; i < 768; i++)
			if (mypal[i] < pal[i]) {
				mypal[i]++;
				done = 0;
			}
	} else {
		for (i = 0; i < 768; i++)
			if (mypal[i]) {
				mypal[i]--;
				done = 0;
			}
	}

	if (done) {
		if (pstate == ST_FADEIN)
			pstate = ST_SUSTAIN;
		else
			pstate = ST_DONE;
		return;
	}

	outp (0x3C8, 0x00);
	for (i = 0; i < 768; i++)
		outp (0x3C9, mypal[i]);
}

void mline (int x0, int y0, int x1, int y1)
{
	double step, other;
	signed short int dx, dy;
	unsigned short int main, ofs, mask;

	dx = x1 - x0;
	dy = y1 - y0;

	if (dx < 0)
		dx = -dx;

	if (dy < 0)
		dy = -dy;

	if (dx > dy) {
		if (x0 > x1) {
			x0 ^= x1 ^= x0 ^= x1;
			y0 ^= y1 ^= y0 ^= y1;
		}

		step = (double) (y1 - y0) / (x1 - x0);
		other = y0;

		for (main = x0; main <= x1; main++) {
			ofs = (int) other * 320 + main;
			mask = ofs & 7;
			ofs >>= 3;

			mbuf[ofs] |= (1 << mask);

			other += step;
		}
	} else {
		if (y0 > y1) {
			x0 ^= x1 ^= x0 ^= x1;
			y0 ^= y1 ^= y0 ^= y1;
		}

		step = (double) (x1 - x0) / (y1 - y0);
		other = x0;

		for (main = y0; main <= y1; main++) {
			ofs = main * 320 + other;
			mask = ofs & 7;
			ofs >>= 3;

			mbuf[ofs] |= (1 << mask);

			other += step;
		}
	}

	ofs = y1 * 320 + x1;
	mask = ofs & 7;
	ofs >>= 3;

	mbuf[ofs] |= (1 << mask);
}

void do_mask (int mphase)
{
	int x, y;

	if (mphase < 320) {
		x = mphase;
		y = 0;
	} else if (mphase < 520) {
		x = 319;
		y = mphase - 320;
	} else if (mphase < 840) {
		x = 319 - (mphase - 520);
		y = 199;
	} else if (mphase < 1040) {
		x = 0;
		y = 199 - (mphase - 840);
	}

	mline (160, 100, x, y);
}

void __interrupt __far new0 (void)
{
	static unsigned short int lticks = 0;

	move_objects();
	do_pal();

	if (mstate == ST_FADEIN) {
		mphase += 8;
		if (mphase > 1040)
			mstate = ST_SUSTAIN;
	}

	if (++lticks >= 65535L * TICK_FREQ / 1193180L) {
		lticks = 0;
		_chain_intr (old0);
	} else _asm {
		mov	al, 20h
		out	20h, al
	};
}

void __interrupt __far new1 (void)
{
	unsigned char ch;

	in_irq1 = 1;

	ch = inp(0x60);
	_asm {
		in	al, 61h
		or	al, 82h
		out	61h, al
		and	al, 7Fh
		out	61h, al
	};

	keytab[ch & 0x7F] = (ch >> 7) ^ 1;

	if (ch == 0x01)
		pstate = ST_FADEOUT;

	in_irq1 = 0;

	_asm {
		mov	al, 20h
		out	20h, al
	};
}

void fill_pal (int start, int len, char sr, char sg, char sb, char er, char eg, char eb)
{
	int i;
	char r, g, b;
	char *p = pal + (start << 1) + start;

	for (i = 0; i < len; i++) {
		r = (i * er + (len - i) * sr) / len;
		g = (i * eg + (len - i) * sg) / len;
		b = (i * eb + (len - i) * sb) / len;
	//	r = (i * (er - sr) / len) + sr;
	//	g = (i * (eg - sg) / len) + sg;
	//	b = (i * (eb - sb) / len) + sb;

		*p++ = r;
		*p++ = g;
		*p++ = b;
	}
}

void init_pal (void)
{
	/*
	 * 1.  1 czarny
	 * 2.  1 czerwony
	 * 3.  1 niebieski
	 * 4.  1 rowy
	 * 5. 32 odcienie brzowotego
	 * 6. 32 odcienie od rowego do niebieskiego
	 * 7.  1 ciemny niebieski
	 * 8.  1 zielony
	 * 9.  1 bkitny
	 * 10. 32 odcienie zielonego
	 */

	bzero (pal, 768);

	pal[0 * 3 + 0] = 0x00;
	pal[0 * 3 + 1] = 0x00;
	pal[0 * 3 + 2] = 0x00;

	pal[1 * 3 + 0] = 0x3F;
	pal[1 * 3 + 1] = 0x00;
	pal[1 * 3 + 2] = 0x00;

	pal[2 * 3 + 0] = 0x00;
	pal[2 * 3 + 1] = 0x00;
	pal[2 * 3 + 2] = 0x3F;

	pal[3 * 3 + 0] = 0x3F;
	pal[3 * 3 + 1] = 0x00;
	pal[3 * 3 + 2] = 0x3F;

	fill_pal (4, 32, 0x3F, 0x20, 0x00, 0x3F, 0x3F, 0x00);
	fill_pal (36, 32, 0x28, 0x00, 0x2F, 0x00, 0x00, 0x3F);

	pal[68 * 3 + 0] = 0x00;
	pal[68 * 3 + 1] = 0x00;
	pal[68 * 3 + 2] = 0x1F;

	pal[69 * 3 + 0] = 0x00;
	pal[69 * 3 + 1] = 0x3F;
	pal[69 * 3 + 2] = 0x00;

	pal[70 * 3 + 0] = 0x00;
	pal[70 * 3 + 1] = 0x3F;
	pal[70 * 3 + 2] = 0x3F;

	fill_pal (71, 32, 0x00, 0x1F, 0x00, 0x00, 0x3F, 0x00);
}

void init (void)
{
	int fq;
	FILE *fp;

	vbuf = (char far *) _fmalloc(64000);
	mbuf = (char far *) _fmalloc(8000);
	bzero (vbuf, 64000);
	bzero (mbuf, 8000);

	sincos = (signed short int *) malloc(2048 * sizeof(signed short int));
	fp = fopen("tables.dat", "rb");
	assert (fp);
	fread (sincos, 2048, sizeof(signed short int), fp);
	fclose (fp);

	pal = (char *) malloc(768);
	init_pal();

	keytab = (char *) malloc(128);
	bzero (keytab, 128);

	init_objects();

	setvmode (0x13);
	outp (0x3C6, 0xFF);
	outp (0x3C8, 0x00);
	for (fq = 0; fq < 768; fq++)
		outp (0x3C9, 0x00);
	make_view();

	old0 = _dos_getvect(0x08);
	old1 = _dos_getvect(0x09);

	fq = 1193180L / TICK_FREQ;
	_asm {
		cli
		mov	al, 3Ch
		out	43h, al
		mov	ax, fq
		xchg	ah, al
		out	40h, al
		xchg	ah, al
		out	40h, al
	};
	_dos_setvect (0x08, new0);
	_dos_setvect (0x09, new1);
	_asm sti;
}

void deinit (void)
{
	_asm {
		cli
		mov	al, 3Ch
		out	43h, al
		mov	al, 0FFh
		out	40h, al
		out	40h, al
	};
	_dos_setvect (0x09, old1);
	_dos_setvect (0x08, old0);
	_asm sti;

	setvmode (0x03);

	deinit_objects();

	free (keytab);
	free (pal);
	free (sincos);
	free (mbuf);
	free (vbuf);
}

void make_view (void)
{
	int y;
	char far *vptr = vbuf;

	for (y = 0; y < 32; y++) {
		memset (vptr, y + 36, 1920);
		vptr += 1920;
	}

	memset (vptr, y + 36 - 1, 2560);

	draw_objects();
}

void mask_view (void)
{
	unsigned short int vofs;
	unsigned int mofs = 0, mask = 0;
	static int omphase = 0;

	while (omphase < mphase)
		do_mask (omphase++);

	for (vofs = 0; vofs < 64000; vofs++) {
		mofs = vofs >> 3;
		mask = vofs & 7;

		if (!(mbuf[mofs] & (1 << mask)))
			vbuf[vofs] = 0;
	}
}

int main (int argc, char **argv)
{
	init();

	while (pstate != ST_DONE) {
		make_view();
		mask_view();
		sync_bufs();
	}

	deinit();

	return 0;
}
